// ----------------------------------------------------------------
// The contents of this file are distributed under the CC0 license.
// See http://creativecommons.org/publicdomain/zero/1.0/
// ----------------------------------------------------------------

import java.awt.event.MouseListener;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;
import java.util.TreeMap;
import java.util.Random;
import java.util.Comparator;

class Controller implements MouseListener, KeyListener
{
	static Random rand = new Random(1234);
	Model model;
	View view;
	boolean training;

	Controller(Model m, View v)
	{
		model = m;
		view = v;
		training = true;
	}

	public void mousePressed(MouseEvent e)
	{
		//model.onClick(e.getX(), e.getY());
	}

	public void mouseReleased(MouseEvent e)
	{
	}

	public void mouseEntered(MouseEvent e)
	{
	}

	public void mouseExited(MouseEvent e)
	{
	}

	public void mouseClicked(MouseEvent e)
	{
	}

	public void keyPressed(KeyEvent e)
	{
		char c = e.getKeyChar();
		if(c == ' ')
		{
			view.visualizing = !view.visualizing; // Toggle the display on/off. (Training is much faster when off.)
			if(view.visualizing)
				System.out.println("Visualize mode (slow)");
			else
				System.out.println("No-visualize mode (fast)");
		}
		else if(c == 't')
		{
			training = !training;
			if(training)
				System.out.println("Now training");
			else
				System.out.println("Now testing");
		}
		else
		{
			int n = e.getKeyCode();
			model.applyForce(0.0);
			if(n == KeyEvent.VK_RIGHT)
				model.applyForce(0.1);
			if(n == KeyEvent.VK_LEFT)
				model.applyForce(-0.1);
		}
	}

	public void keyReleased(KeyEvent e)
	{
	}

	public void keyTyped(KeyEvent e)
	{
	}

	void update()
	{
	}
}
